; This program is made by Daniel Horchner.
; email: dbjh@gmx.net

%define NO_EXTERN       0       ; 'extern' directives must not be included
%include "..\raw32.inc"

segment code32

%include "raw32mod.inc"

;32-bit data
msg             db      'Hello, world! From above 1MB!',0
dosmsg          db      'This message is printed via DOS.',13,10,'$'

;32-bit code
..start:
        times 1024*1024 nop             ; Dummy NOP instr -> >640KB code!

        mov esi,msg
        mov es,[zerosel]
        mov edi,0b8000h+160
        mov bl,1fh
        call far [putstr]

        mov edx,dosmsg
        call dosprintx

        mov esi,0
;        call far [dosshell]

@exit:
        mov byte [returncode],2
        jmp far [exit]                  ; Return to real/V86 mode

;
; Print '$' terminated string via DOS
; In:
;   ds = data32sel
;   edx = offset of '$' terminated string
;
dosprintx:
        push eax
        push ecx
        push esi
        push edi
        push es
        mov ax,ds                       ; First, get string length
        mov es,ax                       ; es=ds for scasb
        mov edi,edx
        mov ecx,0ffffffffh              ; Search max 4GB
        mov al,'$'                      ; Scan for '$' (=end of DOS string)
        cld
        repne scasb                     ; Compare al with es:edi
        not ecx
        mov eax,ecx                     ; ecx=string length (including '$')
        push dword [lomembase]
        call far [getlomem]
        mov esi,edx
        mov edi,eax
        add edi,[code32a]
        mov es,[zerosel]
        cld
        rep movsb
        mov edx,eax
        call far [dosprint]
        pop dword [lomembase]
        pop es
        pop edi
        pop esi
        pop ecx
        pop eax
        ret
